"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApolloClientRegenerator = exports.useApolloClientRegenerator = exports.ApolloClientRegeneratorContext = exports.defaultRegenerateApolloClient = void 0;
const react_1 = __importStar(require("react"));
const client_1 = require("@apollo/client");
const client_2 = require("@deep-foundation/hasura/client");
exports.defaultRegenerateApolloClient = (options) => {
    if (!client_2.generateApolloClient)
        throw new Error("!generateApolloClient");
    return client_2.generateApolloClient(options);
};
exports.ApolloClientRegeneratorContext = react_1.default.createContext({ regenerate: () => { } });
function useApolloClientRegenerator() {
    return react_1.useContext(exports.ApolloClientRegeneratorContext);
}
exports.useApolloClientRegenerator = useApolloClientRegenerator;
exports.ApolloClientRegenerator = react_1.memo(function ApolloClientRegenerator({ options, children = null, useStateApolloClient = react_1.useState, regenerateApolloClient = exports.defaultRegenerateApolloClient, }) {
    const initialApolloClient = react_1.useMemo(() => regenerateApolloClient(options), []);
    const [apolloClient, setApolloClient] = useStateApolloClient(initialApolloClient);
    const mountedRef = react_1.useRef(false);
    react_1.useEffect(() => {
        if (!mountedRef.current)
            mountedRef.current = true;
        else
            setApolloClient(regenerateApolloClient(options));
    }, [options]);
    const context = react_1.useMemo(() => ({
        regenerate: () => {
            setApolloClient(regenerateApolloClient(options));
        },
    }), [options]);
    return react_1.default.createElement(exports.ApolloClientRegeneratorContext.Provider, { value: context },
        react_1.default.createElement(client_1.ApolloProvider, { client: apolloClient }, children));
});
//# sourceMappingURL=apollo-client-regenerator.js.map